;FAT12/16/32 driver layer

 include "settings.inc"
  include "../ti83plus.inc"
 include "equates.inc"
 SEGMENT Main
 GLOBALS ON

 EXTERN DispHexA,DispHexHL,getMSDPtr,getMSDData,getSectorBuffer,UFI_Read,UFI_Write,IGetKey,USBErrorCont,IPutS
 EXTERN UFI_ReadPriority,ILdHLInd,ConvOP1,IsFAT32,IsFAT12

FAT_Initialize:
	;Prepares for FAT12/16/32 file system operations and DOS-like interface
	;Input:      None
	;Output:     None
	;Returns C if error
       LOG FATInit
	call getMSDPtr
	ld l,(ix+MSDPartStart)
	ld h,(ix+MSDPartStart+1)
	ld (ix+MSDLBA),l
	ld (ix+MSDLBA+1),h
	ld l,(ix+MSDPartStart+2)
	ld h,(ix+MSDPartStart+3)
	ld (ix+MSDLBA+2),l
	ld (ix+MSDLBA+3),h
	call getSectorBuffer
	call UFI_Read
	ld hl,13
	add hl,de
	call getMSDPtr
	ld a,(hl)
	ld (ix+MSDSPC),a ;get number of sectors per cluster
       ld de,(cachetemp)
	ld hl,510
	add hl,de
       call ILdHLInd
	ld de,0AA55h ;all partitions have this at +510 bytes
	or a
	sbc hl,de
	ld a,errMSDInvalidPartition
	jr nz,USBErrorCont
       ;get BPB_SectorsPerFAT
       ld ix,(cachetemp)
       ld l,(ix+22)
       ld h,(ix+23)
       call getMSDPtr
       ld (ix+MSDFATSectors),l
       ld (ix+MSDFATSectors+1),h
	;Compute RootDirSectors
	;get BPB_RootEntCnt
       ld ix,(cachetemp)
 IF FAT32_ON = 1
       call IsFAT32
       jr nz,FAT_I_32 ;FAT32 partition, deal with it differently
 ENDIF
	ld l,(ix+17)
	ld h,(ix+18)
	;HL is BPB_RootEntCnt
	;RootDirSectors = (BPB_RootEntCnt * 32) / BPB_BytesPerSec
       add hl,hl ;*2
       add hl,hl ;*4
       add hl,hl ;*8
       add hl,hl ;*16
       add hl,hl ;*32
	B_CALL SetXXXXOP2
	B_CALL OP2ToOP1
       call getMSDPtr
       ld l,(ix+MSDBPS)
       ld h,(ix+MSDBPS+1)
	B_CALL SetXXXXOP2
	B_CALL FPDiv
	call ConvOP1
	call getMSDPtr
	ld (ix+MSDRootDirSectors),e
	ld (ix+MSDRootDirSectors+1),d
	push de
	;FirstDataSector = BPB_ResvdSecCnt + (BPB_NumFATs * BPB_FATSz16) + RootDirSectors
       ld ix,(cachetemp)
	ld a,(ix+16)
	push ix
	B_CALL SetXXOP1
	pop ix
	ld l,(ix+22)
	ld h,(ix+23)
	push ix
	B_CALL SetXXXXOP2
	B_CALL FPMult
	call ConvOP1
	pop ix
	pop hl
	add hl,de
	ld e,(ix+14)
	ld d,(ix+15)
	call getMSDPtr
	ld (ix+MSDFATStart),e
	ld (ix+MSDFATStart+1),d
	add hl,de
	ld (ix+MSDFirstDataSector),l
	ld (ix+MSDFirstDataSector+1),h
	ld e,(ix+MSDRootDirSectors)
	ld d,(ix+MSDRootDirSectors+1)
	or a
	sbc hl,de
	ld (ix+MSDFirstRootDirSecNum),l
	ld (ix+MSDFirstRootDirSecNum+1),h
       ret
 IF FAT32_ON = 1
FAT_I_32:
       ;need to fill in MSDFATStart, MSDFirstDataSector, MSDRootDirSectors, and MSDFirstRootDirSecNum
       ;also fill in MSDFATSectors
       ld l,(ix+14)
       ld h,(ix+15)
       call getMSDPtr
       ld (ix+MSDFATStart),l
       ld (ix+MSDFATStart+1),h
       push hl
       ld ix,(cachetemp)
       ld l,(ix+36)
       ld h,(ix+37)
       add hl,hl
       pop bc
       add hl,bc
       call getMSDPtr
       ld (ix+MSDFirstDataSector),l
       ld (ix+MSDFirstDataSector+1),h
       ld (ix+MSDFirstRootDirSecNum),l
       ld (ix+MSDFirstRootDirSecNum+1),h
       ;xor a ;I don't think these are ever checked in "FAT32 mode"...
       ;ld (ix+MSDRootDirSectors),a
       ;ld (ix+MSDRootDirSectors+1),a
       ret
 ENDIF

       COMMENT ~ This function is never used, but good to have
FAT_getVolumeName:
       ;Input:      None
       ;Output:     HL points to an 11-byte string containing the volume name
       call getMSDPtr
       ld l,(ix+MSDPartStart)
       ld h,(ix+MSDPartStart+1)
       ld (ix+MSDLBA),l
       ld (ix+MSDLBA+1),h
       ld l,(ix+MSDPartStart+2)
       ld h,(ix+MSDPartStart+3)
       ld (ix+MSDLBA+2),l
       ld (ix+MSDLBA+3),h
       call getSectorBuffer
       push de
       call UFI_Read
       pop hl
       ld de,43
       add hl,de
       ret
       ~

FAT_findEmptyEntry:
       ;Searches directory for an empty spot to write new entry
       ;Input:       HL points to the starting cluster of a directory
       ;Output:      HL points to area in sector buffer to write new entry
       ;Notes:       Allocates new clusters to directory if necessary
       ;Returns C if problems or out of memory
       ;This is useful for finding a place for a new directory entry and immediately writing it
       ld (cur_cluster),hl
       xor a
       ld (sector_offset),a
	call FAT_getSectorOfCluster
	call PartitionAdjust
FAT_FFE_SectorLoop:
	call getSectorBuffer
	call UFI_Read
       ex de,hl
	call getMSDPtr
	ld c,(ix+MSDBPS)
	ld b,(ix+MSDBPS+1)
	srl b
	rr c
	srl b
	rr c
	srl b
	rr c
	srl b
	rr c
	srl b
	rr c
	ld b,c
FAT_FFE_Loop:
	ld a,(hl)
	cp 0E5h
	jr z,FAT_FFE_Found
	or a
	jr z,FAT_FFE_Found
	ld de,32
	add hl,de
	djnz FAT_FFE_Loop
	ld a,(ix+MSDSPC)
	ld b,a
	ld a,(sector_offset)
	inc a
	cp b
	jr z,$F
	ld (sector_offset),a
       call LBAPlus1
       jr FAT_FFE_SectorLoop
$$:    ld hl,(cur_cluster)
       call FAT_getNextCluster
       call IsFinalCluster
	jr nc,FAT_findEmptyEntry
;DE contains old cluster
; go to new cluster, zero out
; find new cluster, set old cluster to new one
       call FAT_findFreeCluster
	ld (new_cluster),hl
       ret c
 IF FAT12_ON = 1
       call IsFAT12
       jr z,FAT_FEE_N12
       ;write new sector to DE
       ld bc,0FFFFh
       call FAT_WriteClusterDE
       jr FAT_FEE_Continue
 ENDIF
FAT_FEE_N12:
       ld a,0FFh
       ld (de),a
       inc de
       ld (de),a
 IF FAT32_ON = 1
       call IsFAT32
       jr z,$F
       inc de
       ld (de),a
       inc de
       ld (de),a
 ENDIF
$$:    ld de,(cachetemp)
       call UFI_Write
FAT_FEE_Continue:
       ld hl,(cur_cluster)
	call FAT_getNextCluster ;read in original FAT word
 IF FAT12_ON = 1
       call IsFAT12
       jr z,$F
       ld bc,(new_cluster)
       call FAT_WriteClusterDE
       jr FAT_FEE_Finish
 ENDIF
$$:	ld a,(new_cluster)
	ld (de),a ;overwrite FFFFh with new free cluster
	inc de
	ld a,(new_cluster+1)
	ld (de),a
       ld de,(cachetemp)
	call UFI_Write ;save that
FAT_FEE_Finish:
	ld hl,(new_cluster)
       call FAT_getSectorOfCluster
       call PartitionAdjust
       ;zero out new cluster, just to be safe
       call getSectorBuffer
       ex de,hl
       call getMSDPtr
       ld c,(ix+MSDBPS)
       ld b,(ix+MSDBPS+1)
       B_CALL MemClear
       xor a
       ld (sector_offset),a
FAT_FFE_ZeroCluster:
       call UFI_Write ;write out zeroes
       call getMSDPtr
       ld a,(ix+MSDSPC)
       ld b,a
       ld a,(sector_offset)
       inc a
       cp b
       jr z,$F
       ld (sector_offset),a
       call LBAPlus1
       jr FAT_FFE_ZeroCluster
$$:    ld hl,(new_cluster)
	call FAT_getSectorOfCluster ;load MSDLBA for write to new cluster
	call PartitionAdjust
       call getSectorBuffer
       ex de,hl
       ld (cachetemp),hl
FAT_FFE_Found:
       or a
       ret

FAT_WriteClusterDE:
 IF FAT12_ON = 1
       ;Writes cluster in HL to FAT12 FAT
       ;Input:       HL contains cluster number
       ;             BC contains value to write
       ;Output:      Cluster written
       ;HL contains cluster number
       ;DE points to area in sector buffer to start writing cluster
       ;BC is value to write (0FFFFh, etc.)
       ld a,l
       and 00000001b
       ;modify BC accordingly, carefully write out bytes (minding sector boundaries)
       jr z,$F
       srl b
       rr c
       srl b
       rr c
       srl b
       rr c
       srl b
       rr c
       jr FAT_WCDE_1
$$:    ld a,b
       and 00001111b
       ld b,a
FAT_WCDE_1:
       ld a,c
       ld (de),a
       inc de
       ;new sector?
       push de
       ex de,hl
       ld de,(cachetemp)
       sbc hl,de
       pop de
       jr nz,$F
       push bc
       ld de,(cachetemp)
       call UFI_Write
       call LBAPlus1
       call UFI_ReadPriority
       pop af
       ld (de),a
       call UFI_Write
       jr LBAMinus1
$$:    ld a,b
       ld (de),a
       ld de,(cachetemp)
       jr UFI_Write
 ENDIF

FAT_lookupPath:
	;Searches for a specific file/directory (including path)
	;Input:	HL points to an ASCIIZ string containing a path to a file/directory
	;Output:	HL points to the directory entry for the file/directory
	;C set if not found
	ld a,(hl)
	cp '/'
	ld a,errMSDNotValidPath
	jr nz,USBErrorCont
	inc hl
	;Set root cluster
	ld de,0
FAT_lookupPath_Loop:
	ld a,(hl)
	or a
	scf
	ret z
	push hl
	push de
	ld de,str_temp
	call FAT_nameConvertTo11 ;take one part of the name
	pop hl
	ld de,str_temp
	call FAT_findFileInCluster
	;C set if not found, otherwise HL points to the directory entry
	push hl
	pop ix	;save it just in case
	jr c,FAT_lookupPath_C ;couldn't find it
	ld de,26
	add hl,de
	ld e,(hl)
	inc hl
	ld d,(hl)
	;DE is the first cluster of this file/directory
	;Is there another level to search or are we at the end?
	pop hl
	;If we just did "FOLDER1" out of "/FOLDER2/FOLDER1/FOLDER0", then HL points to
	;the "F" in "FOLDER1".
FAT_lookupPath_1:
	ld a,(hl)
	inc hl
	cp '/'
	jr z,FAT_lookupPath_Loop
	or a
	jr nz,FAT_lookupPath_1
	;we couldn't find anything else, so we must be done
	push ix
       or a
FAT_lookupPath_C:
	pop hl
	ret

FAT_findFileInCluster:
	;Input:      HL is the starting cluster of the directory to search
	;            DE points to the name of a file/directory, 11-character format
	;Output:     HL points to its directory entry
	;C set if not found
FAT_FFIC_Loop:
	push de
	push hl
	call FAT_findEntry ;look in cluster HL
	jr nc,FAT_FFIC_Found
	pop hl
	pop de
	;move to next cluster?
	push de
	call FAT_getNextCluster
	pop de
	;HL is the next cluster
       call IsFinalCluster
       ld a,errMSDNotFound
       jr c,USBErrorCont
	jr FAT_FFIC_Loop
FAT_FFIC_Found:
	pop de
	pop de
	ret

FAT_findEntry:
       ;Finds an entry in a cluster
       ;Input:      HL is the starting cluster of the directory to search
       ;            DE points to the name of a file/directory, 11-character format
       ;Output:     HL points to the start of the file/directory entry
       ;            (MSDLBA) is one past the sector containing file/directory entry (call LBAMinus1 if LBA is needed)
	;C set if not found
	call getMSDPtr
	ld a,h
	or l
	ld a,(ix+MSDSPC)
	ld (SPC_temp),a
	jr nz,FAT_findEntry_Good
 IF FAT32_ON = 1
       call IsFAT32
       jr nz,FAT_findEntry_Good
 ENDIF
	ld a,(ix+MSDRootDirSectors)
 IF FAT12_ON = 1
       call IsFAT12
       jr z,FAT_findEntry_Good
       ld a,16 ;ugly FAT12 hack, see dos.asm
 ENDIF
FAT_findEntry_Good:
	ld (ix+MSDSPC),a
	push de
	call FAT_getSectorOfCluster
	call PartitionAdjust
	ld a,(ix+MSDSPC)
	ld b,a
	pop de
FAT_findEntry_SectorLoop:
	push bc
	push de
	call getSectorBuffer
	call UFI_Read
	pop de
       call LBAPlus1
	push de
       ld hl,(cachetemp)
	pop de
	ld c,(ix+MSDBPS)
	ld b,(ix+MSDBPS+1)
	srl b
	rr c
	srl b
	rr c
	srl b
	rr c
	srl b
	rr c
	srl b
	rr c ;32 bytes per entry
       ld b,c
FAT_findEntry_EntryLoop:
	push bc
	;HL is the entry
	;DE is our string
	;Compare
	push de
	push hl
	ld bc,11
	ld a,(hl)
	or a
	jr z,FAT_findEntry_LastOne
FAT_findEntry_NameCheck:
	ld a,(de)
	inc de
	cpi
	jr nz,FAT_findEntry_SkipAhead
	jp pe,FAT_findEntry_NameCheck
	;Match!
	pop hl
	pop de
	pop bc
	pop bc
	or a
	jr FAT_findEntry_Ret
FAT_findEntry_SkipAhead:
	pop hl
	pop de
	ld bc,32
	add hl,bc
	pop bc
	djnz FAT_findEntry_EntryLoop
	pop bc
	djnz FAT_findEntry_SectorLoop
	scf
FAT_findEntry_Ret:
	ld a,(SPC_temp)
	ld (ix+MSDSPC),a
	ret
FAT_findEntry_LastOne:
	pop hl
	pop de
	pop bc
	pop bc
	scf
	jr FAT_findEntry_Ret

FAT_getEntryInfo:
	;Returns the offsets for bytes, sectors, and clusters for the entry
	;Input:      BC is the entry number
	;            HL is the starting cluster of the directory
	;Output:     IX points to OP6
	;Destroys OP6
	;OP6+1 - 2 bytes, byte offset
	;OP6+3 - 1 byte, sector offset
	;OP6+4 - 2 bytes, cluster offset
	;OP6+6 - 2 bytes, starting cluster
	ld ix,OP6
	ld (ix+6),l
	ld (ix+7),h
	ld h,b
	ld l,c
	ld de,0
	add hl,hl
	rl e
	rl d
	add hl,hl
	rl e
	rl d
	add hl,hl
	rl e
	rl d
	add hl,hl
	rl e
	rl d
	add hl,hl
	rl e
	rl d
	;DEHL is the 32-bit offset of the file from the starting cluster
	;now find the sector offset by dividing by BPS
	ld (ixSave),ix
	call getMSDPtr
	ld c,(ix+MSDBPS)
	ld b,(ix+MSDBPS+1)
	dec bc
	ld a,b
	and h
	ld ix,(ixSave)
	ld (ix+2),a
	ld a,c
	and l
	ld (ix+1),a
	;Divide by BPS
$$:	srl d
	rr e
	rr h
	rr l
	srl b
	rr c
       ld a,b
       or c
	jr nz,$B
	;DEHL is now a sector offset
	ld (ixSave),ix
	call getMSDPtr
	ld a,(ix+MSDSPC)
       dec a
       ld ix,(ixSave)
	push af
	and l
	ld (ix+3),a
	;Divide by SPC
       pop af
$$:	srl d
	rr e
	rr h
	rr l
       srl a
	jr nz,$B
       ld (ix+4),l
	ld (ix+5),h ;HL is the cluster of the offset
	ret

FAT_getStartingCluster:
	;Gets starting cluster of directory (necessary input for some routines)
	;Input:	HL points to ASCIIZ directory path
	;Output:	HL is starting cluster of this directory
	;Returns C if it failed
	;Root directory ("/") will always have 0000h as its starting cluster
	;Also gets starting cluster of files
	ld a,(hl)
	cp '/'
	ld a,errMSDNotValidPath
	jr nz,USBErrorCont
	inc hl
	ld a,(hl)
	dec hl
	or a
	jr z,FAT_GSC_1
	call FAT_lookupPath
	ret c
	ld de,1Ah
	add hl,de
       call ILdHLInd
	or a
	ret
FAT_GSC_1:
	ld hl,0
	or a
	ret

FAT_getNextCluster:
	;Input:	HL is a cluster number
	;Output:	HL is the cluster following this one (the word in the FAT for the input cluster)
	;		(MSDFAT_sector) is sector offset from MSDFATStart where FAT word was found
	;		DE is pointer in sector buffer where FAT word was found
	call getMSDPtr
 IF FAT12_ON = 1
       call IsFAT12
       jr nz,FAT_GNC_12
 ENDIF
 IF FAT32_ON = 1
       call IsFAT32
       jr nz,$F
 ENDIF
	ld a,h	;calculate the sector/offset
	or l
	ret z
       jr FAT_GNC_16
$$:	ld a,h
       or l
       jr nz,FAT_GNC_16
       ld hl,2
FAT_GNC_16:
	xor a
	add hl,hl ;AHL = 2HL
	adc a,a
 IF FAT32_ON = 1
       call IsFAT32
       jr z,FAT_GNC_Continue
       add hl,hl ;AHL = 4HL
       adc a,a
 ENDIF
FAT_GNC_Continue:
       ld e,(ix+MSDBPS)
       ld d,(ix+MSDBPS+1)
       dec de
	push af
	ld a,h
	and d
	ld b,a
	ld a,l
	and e
	ld c,a ;BC = (2AHL) MOD DE or BC = (4AHL) = MOD DE
	pop af
FAT_getNextCluster_1:
	sra a
	rr h
	rr l
	srl d
	rr e
	jr nz,FAT_getNextCluster_1
	;HL is the sector...BC is the offset
	ld (ix+MSDFAT_sector),l
	ld (ix+MSDFAT_sector+1),h
	ld e,(ix+MSDFATStart)
	ld d,(ix+MSDFATStart+1)
	add hl,de
	ld de,0
	call PartitionAdjust
	push bc
	call getSectorBuffer
	call UFI_ReadPriority
       ex de,hl
	pop de
	add hl,de
 IF FAT12_ON = 1
       call IsFAT12
       jr nz,$F
 ENDIF
	push hl
       call ILdHLInd
	pop de
	ret
$$:    ;HL points to area in sector buffer with next cluster
       ;DE is offset in sector buffer with next cluster
 IF FAT12_ON = 1
       ld a,(hl)
       ld (time_temp+1),a
       inc hl
       push hl
       ld hl,512-1
       B_CALL cphlde
       pop hl
       jr nz,$F
       call LBAPlus1
       call getSectorBuffer
       call UFI_ReadPriority
       push de
       call LBAMinus1
       pop hl
$$:    ld a,(time_temp+1)
       ld l,a
       ld h,(hl)
       ld d,h
       ld e,l
       ld a,(time_temp)
       or a
       jr z,$F
       srl h
       rr l
       srl h
       rr l
       srl h
       rr l
       srl h
       rr l
       ret
$$:    ld a,h
       and 00001111b
       ld h,a
       ret
FAT_GNC_12:
       ld a,h
       or l
       ret z
       ld a,00000001b
       and l
       ld (time_temp),a ;used as temporary indicator for which cluster in 3-byte section
       ld d,h
       ld e,l
       xor a
       add hl,hl
       adc a,a
       add hl,de
       jr nc,$F
       inc a
$$:    srl a
       rr h
       rr l
       ;AHL is cluster * 1.5
       jr FAT_GNC_Continue
 ENDIF

FAT_findFreeCluster:
	;Input:	None
	;Output:	HL contains free cluster number
	;		(MSDLBA) points to sector containing free cluster
	;		DE points to area in sector buffer where free cluster was found
	;This is useful if you want to write to a free cluster right after finding it
	;Returns C if no more free memory is available
	call getMSDPtr
	ld de,0
	ld (cluster_temp),de
	ld l,(ix+MSDFATStart)
	ld h,(ix+MSDFATStart+1)
	call PartitionAdjust
FAT_FFC_Loop_1:
	call getSectorBuffer
	call UFI_ReadPriority
       ex de,hl
 IF FAT12_ON = 1
       call IsFAT12
       jr nz,FAT_FFC_12
 ENDIF
	call getMSDPtr
	ld c,(ix+MSDBPS)
	ld b,(ix+MSDBPS+1)
	srl b ;two bytes per FAT cluster entry
	rr c
 IF FAT32_ON = 1
       call IsFAT32
       jr z,FAT_FFC_Loop
       srl b ;no, four :)
       rr c
 ENDIF
FAT_FFC_Loop:
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
 IF FAT32_ON = 1
       call IsFAT32
       jr z,$F
       inc hl
       inc hl
 ENDIF
$$:	ld a,d
	or e
	jr z,FAT_FFC_Done
	ld de,(cluster_temp)
	inc de
	ld (cluster_temp),de
	dec bc
	ld a,b
	or c
	jr nz,FAT_FFC_Loop
	;advance to next sector
       call FAT_OutOfMemory
       ret c
       call LBAPlus1
	jr FAT_FFC_Loop_1
FAT_FFC_Done:
 IF FAT32_ON = 1
       call IsFAT32
       jr z,$F
	dec hl
	dec hl
 ENDIF
$$:    dec hl
       dec hl
	ex de,hl
	ld hl,(cluster_temp)
	ret
 IF FAT12_ON = 1
FAT_FFC_12:
       ld hl,(cluster_temp)
       call FAT_getNextCluster
       push hl
       call FAT_OutOfMemory
       pop hl
       ret c
       ld a,h
       or l
       ret z
       ld hl,(cluster_temp)
       inc hl
       ld (cluster_temp),hl
       jr FAT_FFC_12
 ENDIF

FAT_OutOfMemory:
       ;Determines if MSDLBA is pointing beyond FAT (i.e. out of memory)
       ;Returns C (offErrorCode = errMSDNoMoreMemory) if no more memory
	call getMSDPtr
       ld de,0
       COMMENT ~ I think this logic only works for NumFATs = 1
       ld l,(ix+MSDFATStart)
       ld h,(ix+MSDFATStart+1)
       ld c,(ix+MSDFATSectors)
       ld b,(ix+MSDFATSectors+1)
       add hl,bc
       jr nc,$F
       inc de
       ~
       ld l,(ix+MSDFirstRootDirSecNum)
       ld h,(ix+MSDFirstRootDirSecNum+1)
$$:    ;DEHL is LBA address of end of FAT
       push de
       push hl
	ld e,(ix+MSDLBA)
	ld d,(ix+MSDLBA+1)
	B_CALL cphlde
       pop de
       pop hl
	ret nz
	call getMSDPtr
	ld l,(ix+MSDLBA+2)
	ld h,(ix+MSDLBA+3)
       B_CALL cphlde
	ret nz
	ld a,errMSDNoMoreMemory
	jr USBErrorCont

FAT_getSectorOfCluster:
	;Input:	HL is a cluster number
	;Output:	DEHL is the first sector of that cluster
	call getMSDPtr
	ld a,h
	or l
	jr z,FAT_getSectorOfCluster_Root
	dec hl
	dec hl
	;DEHL = DEHL - 2
	ld de,0
	;Multiply by SPC
	ld a,(ix+MSDSPC)
	ld b,-1
FAT_getSectorOfCluster_1:
	inc b
	rra
	jr nc,FAT_getSectorOfCluster_1
	ld a,b
	or a
	jr z,$F
	;Multiply!
FAT_getSectorOfCluster_2:
	add hl,hl
	rl e
	rl d
	djnz FAT_getSectorOfCluster_2
$$:	;Add FirstDataSector
	ld c,(ix+MSDFirstDataSector)
	ld b,(ix+MSDFirstDataSector+1)
	add hl,bc
	ex de,hl
	ld c,(ix+MSDFirstDataSector+2)
	ld b,(ix+MSDFirstDataSector+3)
	adc hl,bc
	ex de,hl
	ret
FAT_getSectorOfCluster_Root:
	ld de,0
	ld l,(ix+MSDFirstRootDirSecNum)
	ld h,(ix+MSDFirstRootDirSecNum+1)
	ret

IsFinalCluster:
       ;Determines if cluster number is last in chain
       ;Input:       HL is cluster number
       ;Output:      C set if cluster number is final (0FFF8h+)
       ;Destroys BC
       push hl
       dec hl
       dec hl
       ld bc,12h
       add hl,bc
       pop hl
       ret

PartitionAdjust:
       ;Adjusts sector offset for partition offset and stores to (MSDLBA)
	;Input:      DEHL is a sector offset from the volume start
	;Output:     Loads DEHL to (MSDLBA), compensating for the partition location
	call getMSDPtr
	push bc
	ld c,(ix+MSDPartStart)
	ld b,(ix+MSDPartStart+1)
	add hl,bc
	ld (ix+MSDLBA),l
	ld (ix+MSDLBA+1),h
	ex de,hl
	ld c,(ix+MSDPartStart+2)
	ld b,(ix+MSDPartStart+3)
	adc hl,bc
	ld (ix+MSDLBA+2),l
	ld (ix+MSDLBA+3),h
	ex de,hl
	pop bc
	ret

LBAPlus1:
       ;Advances (MSDLBA) one sector
       ;Input:       None
       ;Output:      LBA = LBA + 1
       call getMSDPtr
	ld l,(ix+MSDLBA)
	ld h,(ix+MSDLBA+1)
	ld bc,1
	add hl,bc
	ld (ix+MSDLBA),l
	ld (ix+MSDLBA+1),h
	ld l,(ix+MSDLBA+2)
	ld h,(ix+MSDLBA+3)
	ld bc,0
	adc hl,bc
	ld (ix+MSDLBA+2),l
	ld (ix+MSDLBA+3),h
       ret

LBAMinus1:
       ;Brings (MSDLBA) back one sector
       ;Input:       None
       ;Output:      LBA = LBA - 1
       call getMSDPtr
       ld l,(ix+MSDLBA)
       ld h,(ix+MSDLBA+1)
       ld bc,1
       or a
       sbc hl,bc
       ld (ix+MSDLBA),l
       ld (ix+MSDLBA+1),h
       ld l,(ix+MSDLBA+2)
       ld h,(ix+MSDLBA+3)
       ld bc,0
       sbc hl,bc
       ld (ix+MSDLBA+2),l
       ld (ix+MSDLBA+3),h
       ret

FAT_getDateWord:
	;Gets current date from 84+/SE clock and formats as 16-bit word for FAT16
	;Input:	None
	;Output:	DE contains FAT16-formatted word of current date
	;HL is preserved
	push hl
	B_CALL GetDate
	B_CALL PopRealO1
	B_CALL ConvOP1
	ld (time_temp),a
	B_CALL PopRealO1
	B_CALL ConvOP1
	ld (time_temp+1),de
	B_CALL PopRealO1
	B_CALL ConvOP1
	ex de,hl
	ld de,1980
	or a
	sbc hl,de
	add hl,hl ;<- 1
	add hl,hl ;<- 2
	add hl,hl ;<- 3
	add hl,hl ;<- 4
	add hl,hl ;<- 5
	add hl,hl ;<- 6
	add hl,hl ;<- 7
	add hl,hl ;<- 8
	add hl,hl ;<- 9
	ex de,hl
	ld hl,(time_temp+1)
	add hl,hl ;<- 1
	add hl,hl ;<- 2
	add hl,hl ;<- 3
	add hl,hl ;<- 4
	add hl,hl ;<- 5
	ld a,h
	or d
	ld d,a
	ld a,l
	or e
	ld e,a
	ld a,(time_temp)
	or e
	ld e,a
	pop hl
	ret

FAT_getTimeWord:
	;Gets current time from 84+/SE clock and formats as 16-bit word for FAT16
	;Input:	None
	;Output:	DE contains FAT16-formatted word of current time
	;Note - HL is preserved
	push hl
	B_CALL GetTime
	B_CALL PopRealO1
	B_CALL ConvOP1
	ld (time_temp),a
	B_CALL PopRealO1
	B_CALL ConvOP1
	ld (time_temp+1),de
	B_CALL PopRealO1
	B_CALL ConvOP1
	ld de,0
	or a
	rla
	or a
	rla
	or a
	rla
	or d
	ld d,a
	ld hl,(time_temp+1)
	add hl,hl ;<- 1
	add hl,hl ;<- 2
	add hl,hl ;<- 3
	add hl,hl ;<- 4
	add hl,hl ;<- 5
	ld a,h
	or d
	ld d,a
	ld a,l
	or e
	ld e,a
	ld a,(time_temp)
	sra a
	or e
	ld e,a
	pop hl
	ret

FAT_nameConvertFrom11:
	;Converts a filename like "README  TXT" into an ASCIIZ string
	;Input:	HL points to 11-character format filename
	;		DE points to 13-byte buffer (at most)
	;Output:	HL points to ASCIIZ string of filename
	push de
	ld b,8
	call FAT_NCFES
	ld a,'.'
	ld (de),a
	inc de
	ld b,3
	call FAT_NCFES
	;Check if there was no extension...then remove period
	dec de
	ld a,(de)
	cp '.'
	jr z,FAT_NCFES_1
	inc de
FAT_NCFES_1:
	xor a
	ld (de),a
	pop hl
	ret
FAT_NCFES:
	ld a,(hl)
	cp ' '
	jr z,$F
	ld (de),a
	inc de
$$:    inc hl
	djnz FAT_NCFES
	ret

FAT_nameConvertTo11:
	;Converts a filename like "readme.txt" into "README  TXT" (11-character format)
	;Input:	HL points to filename (can be ASCIIZ or terminated with forward slash)
	;		DE points to 11-byte buffer for formatted name (OP1-OP6 work well for this)
	;Output:	HL points to 11-character formatted name
	push de
	ld b,8
	call FAT_nameConvert_Subroutine
	ld b,3
	call FAT_nameConvert_Subroutine
	pop hl
	ret
FAT_nameConvert_Subroutine:
	;Input - HL is source. DE is destination. B is the number of bytes to fill.
	ld a,(hl)
	cp '.'
	jr z,FAT_NC_1
	cp '/'
	jr z,FAT_NC_1
	or a
	jr z,FAT_NC_1
	cp 'a'
	jr c,$F
	cp 'z'+1
	jr nc,$F
	add a,'A'-'a'
$$:    ld (de),a
	inc hl
	inc de
	djnz FAT_nameConvert_Subroutine
	jr FAT_NC_Ret
FAT_NC_1:
	ld a,' '
	ld (de),a
	inc de
	djnz FAT_NC_1
FAT_NC_Ret:
	ld a,(hl)
	cp '.'
	ret nz
	inc hl
	ret
