;Version 0.12        
; Fixed bug in ReadDescriptor which crashed on errors when reading string descriptors
; Fixed bug in DOS_fileWrite which incorrectly resized some files when writing
; Fixed bug in DOS_renameFileEntry involving off-by-one LBA problem
; Interrupt now signals to SendControlData (and anything else that waits on port 82) that port 82 reported
;  success.  This fixes a bug with control requests that timed out if the device did not respond immediately.
; Added driver to control Vernier Easy and Go! products, in particular Go/EasyTemp
; DOS_fileWrite should be faster
; Improved MSD driver support
; Added pump entry points to allow use of usb8x without interrupts
; Added caching code
; Experimental FAT12/FAT32 MSD code added and is conditional
; Individual drivers can be compiled out via settings
; Hub code now works.  AutoSetup will pass through to the first non-hub device it finds on the bus.
;Entry Points Added:
; Asm - VernierVersion - Get version and RAM requirements of vernier driver
; Asm - EasyTempInit - Initialize driver and Go/EasyTemp device
; Asm - VernierSendCmd - Send a command block to a vernier device
; Asm - VernierQuickCmd - Send a simple command to a vernier device
; Asm - VernierGetMeas - Get the latest measurement returned by vernier device
; Asm - VernierToDegree - Convert voltage to degree
; Asm - DOS_updateAttributes - update "last modified" date/time and other attributes
; Asm - PumpOn - Turns on pump (disables usb hook stuff)
; Asm - PumpOff - Turns off pump (enables usb hook stuff)
; Asm - Pump - Pump (emulates interrupt.  call in your main loop)
; Asm - CacheOn - Turn on MSD caching
; Asm - CacheOff - Turn off MSD caching
; Asm - msdDetect - Mass storage version of ionDetect to search for and load 83P/8XP levels from specified directory
; BASIC - USBInit - initializes and supplies power to USB port (useful for power-only devices like USB lights)

;Version 0.11
; INPUTS TO MOUSE DRIVER CHANGED
; Logging support is disabled by default
; Removed USBInfo and demos
; Callback is now driver-wide instead of a per-pipe .  This means SetupInPipe no longer takes callback as input
; Converted remaining routines to restore interrupts to original state instead of di/ei
; Added keyboard, silverlink, and gamepad drivers
; Removed lots of old code that wasn't being used anymore
; Mouse (and kbd) driver can now passthrough callbacks to user program
; DISAVE/EIRESTORE now compile time option because it was (maybe?) causing trouble
; MSD callback saves/restores ix
; Restructured interrupt to allow for logging
; Added compile time option to turn on/off logging for individual log entry types
; Added assertion macros/compile-time option
; Added compile time option for assertion-checking IM2 interrupt
; Entry points can now have IX inputs
; DriverInit checks base code version for 2.30+
; Driver routines now kill host device if driver init fails
;Entry Points Added:
; Asm - KBDInit - Initialize keyboard driver
; Asm - KBDGetKey - Get keypress from keyboard
; Asm - KBDGetMods - Get modifier/lock key status
; Asm - KBDCheckDirect - Check current keyboard matrix status
; Asm - SilverInit - Initialize silverlink
; Asm - SilverSend - Send data on silverlink
; Asm - SetCallBack - Sets the callback address
; Asm - PadInit - Initialize gamepad driver
; Asm - PadSetup - Get a key mapping
; Asm - PadStart - Start passing pad information to the callback function
; Asm - GetErrorCode - Get the current error code
; Asm - SendControlDataOut - Send a control command that includes outbound data stage
; BASIC - KBDInit
; BASIC - KBDGetKey
;Known bugs:
; Interrupts may be getting disabled at some point.  Use ei in mousegetkey and kbdgetkey loops.
; AutoSetup may leave device in various states of initialization on error instead of killing it.
; Some drivers don't seem to work as well (at all?) on boot code 1.00
;To Do:
; Add Silver BASIC entry points
; Add option to KBDInit to set up something (cursor hook?) to implement key repeat

;Version 0.10
; Input list to BASIC library no longer required to be 7 elements long 
; KillUSB BASIC entry point now disables driver as well killing the device
; ExecLib now returns error via list rather than system error on non-existant entry point
;Other:
; BASIC entry points now require 42 bytes of free RAM to execute
;Entry Points Added:
; BASIC - GetIDs
; BASIC - GetClass
; BASIC - Version
; BASIC - MSDInit - Initializes mass storage driver
; BASIC - MSD_ImportVariable - Imports *.8x* file from specified directory and stores as variable in RAM/Flash
; BASIC - MSD_ExportVariable - Exports variable in RAM/Flash to specified directory as *.8x* file
; Asm - KBDVersion - Returns version/memory needed for kbd driver
; MSD - MSDVersion - Returns major/minor version and memory requirements of mass storage driver
; MSD - MSD_Initialize - Initializes mass storage device
; MSD - UFI_Initialize - Initializes mass storage device for sector read/write operations
; MSD - UFI_Read - Reads one sector of LBA address into sector buffer
; MSD - UFI_Write - Writes one sector of data from sector buffer to LBA address
; MSD - FAT_Initialize - Initializes mass storage device for FAT16 file system operations
; MSD - FAT_lookupPath - Sees if a file in specified folder exists
; MSD - DOS_openFile - Open file in specified folder for reading/writing by populating file handle (memory buffer)
; MSD - DOS_fileSeek - Adjusts seek pointer in specified file handle
; MSD - DOS_fileRead - Reads bytes from a file at current seek pointer
; MSD - DOS_fileWrite - Writes bytes to a file at current seek pointer, increasing file size if necessary
; MSD - DOS_createFile - Creates new, empty file in specified directory
; MSD - DOS_createDirectory - Creates new, empty directory in specified directory
; MSD - DOS_deleteFileEntry - Deletes file or folder, recursing through files/folders inside as necessary
; MSD - DOS_countFilesInDir - Returns number of file/folder entries in specified directory
; MSD - DOS_getNextFile - Gets next file in list from a specified directory
; MSD - FAT_getStartingCluster - Gets starting cluster of specified directory (necessary input for some routines)
; MSD - MSD_ImportVariable - Imports *.8x* file from specified directory and stores as variable in RAM/Flash
; MSD - MSD_ExportVariable - Exports variable in RAM/Flash to specified directory as *.8x* file
; MSD - DOS_getFileSize - Gets file size from specified directory entry
; MSD - DOS_getDirEntry - Gets directory entry for specified file/directory

;Version 0.09
; Changed descriptor equates and added more for other descriptor types
; Added logging and log viewer
; Added code to load HID report descriptor
; Added SendDataPart entry point.  Hopefuly temporarily
; Added hub related stuff:
;  SetAddress now sets next available address instead of constant address
;  Added SetHubFeature and ClearHubFeature calls
;  Added SetHubPortFeature and ClearHubPortFeature calls
;  Added GetHubStatus and GetHubPortStatus calls
;  Added appropriate desc and log equates
; Added prelim hub demo code (doesn't work)
; Added prelim calc-calc code (doesn't work)
; Sporadic crashes on exit from app.  Cause?
; GetPipeInfo can now return both pipeIn and pipeOut
; MSD demo now autodetects correct output pipe
; Added FindPipe entry point to return the address of a pipe based on characterisitics
; DriverInit now returns error if OS version isn't high enough
; Added a LogCustom entry point to allow apps to make entries in the log file
;Bugs fixed:
; Fixed bug with logging (otir replacement crashed on odd sizes)
; Devices with I and O endpoints at same addr should work
; Minor fix to U_CALL system (allows multipage apps)
;Other:
; Added errDemo and errFindPipe
; Added pipeBitIn and pipeBitOut equates
; Renamed usbInt and usbBulk to pipeInt and pipeBulk
; Created usb8xtsm.inc include file in TASM compatible syntax
;Known bugs:
; Interrupts are getting disabled at some point.  Requires ei in mousegetkey loop.
; USBInfo interface has some bugs.

;Version 0.08
; Graphlink code now checks to make sure a graphlink is connected
; Fixed a bug in GetIDs
; Any call using ReadDescriptor (e.g. GetIDs and GetClass) will now work after AutoSetup
;  however, don't use any of these calls inside of an interrupt.
; Added preliminary mouse driver
; Added di/ei to SendControlData as well (so don't use in int)
; Reworked menu scheme because there's flash test code now.
; SendControlData now takes argument for how much data to recieve in response
; Callback routine can now be passed cbStall or cbNak
; Fixed stupid bug in SendData
; Exposed WaitTimerB entry point
; Added GetPipeInfo entry point and test code to info section
; Lowered mouse movement threshold to fifteen ticks/pixel

;Version 0.07
; Changed appname to "USB8X" from "USBDRV8X" because of TIOS bugs
; Added BASIC interface through OpenLib and ExecLib
; Prettied the graphlink demo a little bit
; Fixed crashing problem on port 82 and 91 errors
; Created KillDriver call, and took that functionality out of HostKill
; Fixed some random bugs
; Tried adding back in the routine to kill host before init if necessary
;  and took it back out again.  *sigh*
; Added about screen

;Version 0.06
; Added conditional code to port 3A check because it wasn't working on
;  certain calculators (boot 1.00?).
; Changed appname to USB8X
; Added entry point for ReqData
; Minimum OS version 2.30

;Version 0.05
; Added OTG descriptor information
; Added AutoSetup.  Works for mouse and graphlink at least.
; Added error reporting to routines
; Initial public release

;Version 0.04
; Transitioned to USB hook for interrupt data handling
; Added lots of important code
; Added silverlink demo

;Version 0.03
; Removed unneccessary stuff
; Fixed endpoint descriptor interval display
; Created entry point table and accessor

;Version 0.02
; Added display template for HID descriptor
; Got mouse cursor demo working
; Mouse mapped to kbdScanCode demo working

;Version 0.01
; Port Logging and Log viewing works
; Port view now unimplimented
; USB initialization and read/display of descriptors works
; USB device configuration works

;Version 0.00
;Port monitor functionality converted to ZDS form

 include "settings.inc"            ; Specific settings for this application
 include "../ti83plus.inc"
 include "equates.inc"             ; Equates and macros to be used
 include "header.asm"              ; The header data.  You don't need to touch this
 EXTERN DoMenu,USBErrorEPIndex,IsDeviceConnected,USBHostInit,KillUSBDevice,ConfigureDevice
 EXTERN ReadDescriptor,USBInitPipe,GetIDs,SetupOutPipe,SetupInPipe,GetClass,FindDescriptor
 EXTERN SendData,AutoSetup,SendControlData,USBReqData,DispHexA,MouseInit,MouseGetKey
 EXTERN WaitTimerB,GetPipeInfo,SendDataPart,FindPipe,SetupLog,StopLog,LogCustom,KBDVersion
 EXTERN MSDVersion,MSD_Initialize,UFI_Initialize,UFI_Read,UFI_Write,FAT_Initialize
 EXTERN FAT_lookupPath,DOS_openFile,DOS_fileSeek,DOS_fileRead,DOS_fileWrite,DOS_createFile
 EXTERN DOS_createDirectory,DOS_countFilesInDir,DOS_getNextFile,DOS_deleteFileEntry
 EXTERN FAT_getStartingCluster,MSD_ImportVariable,MSD_ExportVariable,DOS_renameFileEntry
 EXTERN FAT_nameConvertFrom11,FAT_nameConvertTo11,FAT_findFileInCluster,DOS_getFileSize,WaitTimer32
 EXTERN DOS_getDirEntry,IPutS,IGetKey,KBDInit,KBDGetKey,IPutC,PadVersion,Send8PortA0,SendControlCmd
 EXTERN KBDGetMods,KBDCheckDirect,SilverInit,SilverSend,SetCallBack,PadInit,PadSetup,PadStart,SendControlOut
 EXTERN DispHexHL,SetupUSBHook,USBErrorVersion,VernierInit,VernierQuickCmd,VernierGetMeas,INewLine
 EXTERN VernierToDegree,VernierVersion,VernierSendCmd,DOS_updateAttributes,Pump,PumpOn,PumpOff
 EXTERN CacheOn,CacheOff,IsCacheOn,IsInCache,HubTest,msdDetect

 SEGMENT MAIN
 GLOBALS ON



Init:


       call   HubTest
       call   PumpOff
       call   StopLog
       B_JUMP JForceCmdNoChar

       B_CALL ForceFullScreen
       B_CALL SetTblGraphDraw
       set    appAutoScroll,(iy+appFlags)

       B_CALL ClrLCDFull
       B_CALL HomeUp
       ld     hl,TitleScreen
       call   IPutS

       ld     hl,appBackUpScreen
       call   DriverInit

       call   MSDVersion
       ld     de,saveSScreen
       push   de
       add    hl,de
       ex     de,hl
       pop    hl
       call   MSD_Initialize
       jr     c,DemoError
       call   UFI_Initialize
       jr     c,DemoError
       call   FAT_Initialize
       jr     c,DemoError

;       ld     hl,8000h
;       ld     b,86h
;       call   SetupLog
;       B_CALL GrBufClr



       ld     b,1
       ld     c,4
       ld     d,84h
       ld     e,4
       call   CacheOn

;       call   getMSDPtr
;       ld     (ix+MSDLBA),0
;       ld     (ix+MSDLBA+1),0
;       ld     (ix+MSDLBA+2),0
;       ld     (ix+MSDLBA+3),0
;       call   UFI_Read
;       ld     (ix+MSDLBA),1
;       call   UFI_Read
;       ld     (ix+MSDLBA),0
;       call   UFI_Read
;       call   UFI_Write
       B_CALL ClrLCDFull
       B_CALL HomeUp
       res    appAutoScroll,(iy+appFlags)

       ld     hl,FileName2
       ld     de,OP1
       ld     bc,20
       ldir

       ld     hl,OP1
       ld     de,plotSScreen+512;FHandBuf
       call   DOS_openFile
       jr     c,DemoError

       ld     bc,0
loopy:
       push   bc
       ld     de,plotSScreen
       ld     hl,plotSScreen+512;FHandBuf
       ld     bc,512
       call   DOS_fileRead
       pop    bc
       ld     a,(plotSScreen)
       cp     c
       jr     nz,bad
       inc    bc
       ld     hl,1000
       or     a
       sbc    hl,bc
       jr     nz,loopy


       call   CacheOff
       call   KillUSBDevice
       call   KillDriver
       call   IGetKey


 COMMENT ~
       ld     a,'1'
       call   IPutC
       xor    a
       call   SetMSDLBA
       call   TestRead
       ld     a,'2'
       call   IPutC
       xor    a
       call   SetMSDLBA
       call   TestRead
       ld     a,'3'
       call   IPutC
       ld     a,1
       call   SetMSDLBA
       call   TestRead
       ld     a,'4'
       call   IPutC
       ld     a,2
       call   SetMSDLBA
       call   TestRead
       ld     a,'5'
       call   IPutC
       ld     a,1
       call   SetMSDLBA
       call   TestRead
       ld     a,'6'
       call   IPutC
       xor    a
       call   SetMSDLBA
       call   TestRead
       ld     a,'7'
       call   IPutC
       call   TestRead
       ld     a,'8'
       call   IPutC
       ld     a,2
       call   SetMSDLBA
       call   TestRead

       call   StopLog
       call   CacheOff
       call   KillUSBDevice
       call   KillDriver
       call   IGetKey
 ~
 
 COMMENT ~
       ld     hl,appBackUpScreen
       call   DriverInit

       ld     de,saveSScreen+256
       ld     hl,saveSScreen
       call   EasyTempInit
       jr     nc,$f
       call   GetErrorCode
       push   bc
       pop    hl
       call   DispHexHL
       call   IGetKey
$$:

       ld     de,0
       ei
DLoop:
       push   de
       call   VernierGetMeas
       pop    de
       B_CALL CpHLDE
       push   hl
       jr     z,$f
       ld     b,1
       call   VernierToDegree
       ld     a,4
       B_CALL FormReal
       ld     hl,OP3
       call   IPutS
       call   INewLine

$$:

       B_CALL GetCSC
       pop    de
       cp     skClear
       jr     nz,DLoop


       call   IGetKey          
       call   KillUSBDevice
       call   KillDriver
 ~
       B_JUMP JForceCmdNoChar

bad:
       push   bc
       call   CacheOff
       call   KillUSBDevice
       call   KillDriver
       ld     a,'E'
       call   IPutC
       pop    hl
       call   DispHexHL
       call   IGetKey
       B_JUMP JForceCmdNoChar


FileName2:
       db     "/readme.txt",0
DemoError:
       B_CALL ClrLCDFull
       B_CALL HomeUp
       ld     a,'E'
       call   IPutC
       call   GetErrorCode
       push   bc
       pop    hl
       B_CALL DispHL
       call   IGetKey
       call   KillUSBDevice
       call   KillDriver
       B_JUMP JForceCmdNoChar
TitleScreen:
       db     "   usb8x v0.12  "
       db     "                "
       db     "TI-84 USB Driver"
       db     "                "
       db     "Website:        "
       db     "usb.denglend.net"
       db     "                "
       db     "(Press any key)",0




AppEntry:
       cp     NumEntryPoints
       jr     nc,USBErrorEPIndex
       push   hl
       push   de
       ld     l,a
       ld     h,0
       add    hl,hl
       ld     de,EntryPointTable
       add    hl,de
       ld     e,(hl)
       inc    hl
       ld     d,(hl)
       ex     de,hl
       pop    de
       ex     hl,(sp)
       ret
EntryPointTable:
       dw     GetVersion
       dw     DriverInit
       dw     IsDeviceConnected
       dw     USBHostInit
       dw     KillUSBDevice
       dw     ReadDescriptor
       dw     GetIDs
       dw     GetClass
       dw     ConfigureDevice
       dw     SetupOutPipe
       dw     SetupInPipe
       dw     FindDescriptor
       dw     SendData
       dw     AutoSetup
       dw     SendControlData
       dw     USBReqData
       dw     KillDriver
       dw     MouseInit
       dw     MouseGetKey
       dw     WaitTimerB
       dw     GetPipeInfo
       dw     SetupLog
       dw     SendDataPart
       dw     FindPipe
       dw     StopLog
       dw     LogCustom
       dw     KBDVersion
       dw     MSDVersion
       dw     MSD_Initialize
       dw     UFI_Initialize
       dw     UFI_Read
       dw     UFI_Write
       dw     FAT_Initialize
       dw     FAT_lookupPath
       dw     DOS_openFile
       dw     DOS_fileSeek
       dw     DOS_fileRead
       dw     DOS_fileWrite
       dw     DOS_createFile
       dw     DOS_createDirectory
       dw     DOS_deleteFileEntry
       dw     DOS_countFilesInDir
       dw     DOS_getNextFile
       dw     FAT_getStartingCluster
       dw     MSD_ImportVariable
       dw     MSD_ExportVariable
       dw     DOS_renameFileEntry
       dw     FAT_nameConvertTo11
       dw     FAT_nameConvertFrom11
       dw     FAT_findFileInCluster
       dw     DOS_getFileSize
       dw     DOS_getDirEntry
       dw     KBDInit
       dw     KBDGetKey
       dw     KBDGetMods
       dw     KBDCheckDirect
       dw     SilverInit
       dw     SilverSend
       dw     SetCallBack
       dw     PadInit
       dw     PadSetup
       dw     PadStart
       dw     GetErrorCode
       dw     PadVersion
       dw     InternalInfo
       dw     SendControlOut
       dw     VernierVersion
       dw     VernierInit
       dw     VernierSendCmd
       dw     VernierQuickCmd
       dw     VernierGetMeas
       dw     VernierToDegree
       dw     DOS_updateAttributes
       dw     PumpOn
       dw     PumpOff
       dw     Pump
       dw     CacheOn
       dw     CacheOff
       dw     msdDetect
NumEntryPoints EQU ($-EntryPointTable)/2


InternalInfo:
;Input
; DE = location to load internal info
       ld     hl,InternalInfoTable
       ld     bc,InternalInfoSize
       ldir
       xor    a
       ret
 SEGMENT TextSpace
TLabel: db 0
 SEGMENT Main
InternalInfoTable:
       db     28
       db     NumEntryPoints
       db     fHandleLen
       db     LOGGING_ON
       db     ASSERT_ON
       db     INTERRUPTMACRO_TYPE
       db     SAFETYINT_ON
       db     ALWAYSCANCELINT_ON
       dw     UVersion
       dw     KVersion
       dw     MVersion
       dw     PVersion
       dw     driverMemSize
       dw     kbdMemSize
       dw     msdMemSize
       dw     padMemSize
       dw     mouseMemSize
       dw     msdBufferSize
       dw     msdSectorSize
       dw     TLabel-4000h 
       dw     VVersion
       dw     vernierMemSize
       db     CACHE_ON
       db     KBD_ON
       db     MOUSE_ON
       db     PAD_ON
       db     MSD_ON
       db     SILVER_ON
       db     VERNIER_ON
InternalInfoSize EQU $-InternalInfoTable


KillDriver:
       LOG    KillDriver
       B_CALL ClrUSBHook
 IF SAFETYINT_ON=1
       im     1
 ENDIF

       ret

DriverInit:
;Init hook or int here if neccessary
; NC = success

       B_CALL GetBaseVer
       cp     2
       jr     c,USBErrorVersion
       ld     a,29
       cp     b
       jr     nc,USBErrorVersion
       ld     (MemPtr),hl
       ld     bc,driverMemSize
       B_CALL MemClear
 IF SAFETYINT_ON=1       
       in     a,(6)
       ld     (0FFFBh),a

	ld	hl,tempintcode
	ld	de,8A8Ah
	ld	bc,tempintsize
	ldir


	ld	hl,8B00h
	ld	a,h
	ld	i,a
	dec	a			;$8A
	ld	bc,257
       B_CALL MemSet
       im     2
       ei
 ENDIF
       call   SetupUSBHook
       xor    a

       ret

 IF SAFETYINT_ON=1
tempintcode:
       exx
       ex     af,af'
       ld     hl,(MemPtr)
       ld     b,1
       ld     a,h
       cp     9Dh
       jr     nc,tempintboo
       cp     80h
       jr     c,tempintboo
       ld     de,offErrorCode
       add    hl,de
       ld     b,2
       ld     a,(hl)
       cp     41
       jr     nc,tempintboo
       inc    hl
       ld     a,(hl)
       cp     41
       jr     nc,tempintboo
       exx
       ex     af,af'
       jp     38h
tempintboo:
       im     1
       ld     c,a
       in     a,(6)
       push   af
       push   af
       push   af

       ld     a,(0FFFBh)
       out    (6),a
       ld     a,c
       call   DoAssert
tempintsize EQU $-tempintcode       
 ENDIF
GetVersion:
;Returns 
; H = major version
; L = minor version
; DE = size of buffer required for DriverInit
       ld     de,driverMemSize
       ld     hl,UVersion
       ret



CheckUSBHook:
       bit    0,(iy+3Ah)
       ret


DoAssert:
 IF ASSERT_ON=1
       di
       push   bc
       push   af
       B_CALL ClrLCDFull
       di
       ld     hl,0
       ld     (curRow),hl
       ld     hl,AssertTXT
       call   IPutS
       pop    af
       call   DispHexA
       ld     a,','
       call   IPutC
       pop    af
       call   DispHexA
       B_CALL NewLine
       ld     hl,AssertAtTXT
       call   IPutS
       pop    hl
       call   DispHexHL
       B_CALL NewLine
       ld     hl,AssertStackTXT
       call   IPutS
       pop    hl
       pop    hl
       ld     b,14
$$:
       pop    hl
       call   DispHexHL
       ld     a,','
       call   IPutC
       djnz   $b
       di

       ld     a,3
       out    (5),a
       ld     hl,8000h
       ld     de,0C000h
       ld     bc,4000h
       ldir
       xor    a
       out    (5),a

       ld     a,84h
       out    (7),a
       ld     hl,0C000h
       ld     de,8000h
       ld     bc,4000h
       ldir



       halt


AssertTXT:
       db     "Assert triggered"
       db     "between: ",0
AssertAtTXT:
       db     "At: ",0
AssertStackTXT:
       db     "Stack: ",0
 ELSE
       ret
 ENDIF


GetErrorCode:
;Loads B with ErrorCode and C with SubErrorCode
       push   hl
       ld     hl,(MemPtr)
       ld     bc,offErrorCode
       add    hl,bc
       ld     b,(hl)
       inc    hl
       ld     c,(hl)
       pop    hl
       ret



  if DEV=PROD
 if CALC=TI73
  warning "TI-73 Freeware"
 endif
 endif
 if DEV=BETA
 if CALC=TI83P
  warning "TI-83P devkey"
 endif
 endif