 include "settings.inc"
  include "../ti83plus.inc"
 include "equates.inc" 
 SEGMENT Main
 GLOBALS ON
 EXTERN DispHexA,DoAssert
;Routines related to interrupt handling




SetupUSBHook:
       ld     hl,USBIntHandle
       in     a,(6)
       B_CALL SetUSBHook
       or     a
       ret

USBIntHandle:
       add    a,e


       in     a,(55h)
       ld     b,a
       in     a,(56h)
       LOG    Interrupt,b
       LOG    Interrupt,a

;       call   CheckPump           ;Shouldn't be needed with 5B stuff
;       jr     nz,USBIntCancel

       bit    4,b
       jr     z,USBIntData
USBIntGoTIOS:
 IF ALWAYSCANCELINT_ON = 1
       ld     b,0
 ELSE
       ld     b,1                  ;Not handling other cases for now.
 ENDIF
       ret


Pump:

       push   af
       push   bc
       push   de
       push   hl
       call   CheckPump
       LOG    Pump,(hl)
       call   nz,USBIntData
       pop    hl
       pop    de
       pop    bc
       pop    af
       ret

USBIntData:


       in     a,(8Fh)
       LOG    Interrupt,a
       bit    2,a                  ;from above
;       jr     z,USBIntGoTIOS       ;Not handling if we're a peripheral

       in     a,(86h)
       LOG    Interrupt,a
       res    5,a
       or     a
       jr     nz,USBIntGoTIOS      ;Not handling if there's an error (what error?)

       in     a,(82h)
       LOG    Interrupt,a             ;****TESTING
       or     a
       jr     nz,FlagPort82


       in     a,(84h)
       LOG    Interrupt,a
       and    0FEh
       jr     z,USBIntGoTIOS       ;No incoming data (other than control)
       ld     b,a

       in     a,(8Eh)
       push   af
       ld     a,b
       ld     c,9Fh
$$:
       inc    c
       rra
       jr     nc,$b
       ld     a,c                  ;C = port associated with incoming data
       sub    0A0h                  ;A = pipe/endpoint #
       LOG    Interrupt,a
       out    (8Eh),a
       ld     e,a

       in     a,(94h)
       LOG    Interrupt,a
       ld     b,cbStall
       bit    2,a
       jr     nz,SkipReadData
       bit    6,a
       ld     b,cbNak
       jr     nz,SkipReadData
;       ld     b,cbOther
;       or     a
;       jr     nz,SkipReadData

       ld     d,0
       ld     hl,(MemPtr)
       add    hl,de
       ld     de,offPacketSizeTable
       add    hl,de
       ld     b,(hl)               ;B = packet size to read from this pipe
       ld     hl,(MemPtr)          ;Don't need an offset for inBuf
       ASSERTC h,9Dh
       ASSERTC 7Fh,h
       in     a,(96h)
       ld     e,a
       in     a,(97h)
       ld     d,a                  ;ummm.... Shouldn't these be used?
 IF LOGGING_ON=0
       inir
 ELSE
       ASSERTNC 40h,b
       LOG    InData,c
       LOG    DataStart,b
$$:
       in     a,(c)
       LOG    Data,a
       ld     (hl),a
       inc    hl
;       dec    b
;       jr     nz,$b
       djnz   $b
 ENDIF
       ld     b,cbNewData
       LOG    DataEnd
SkipReadData:
       xor    a
       out    (94h),a
       LOG    CallBack,b
       call   CallBack
       pop    af
       out    (8Eh),a
USBIntCancel
       ld     b,0
       ret


FlagPort82:
       ld     hl,(MemPtr)
       ld     de,offFlags
       add    hl,de
       set    flagPort82,(hl)
       jr     USBIntCancel


CallBack:
;Calls the callback for the currently selected endpoint
;Cancel if callback address is 0
;Gives it message in B
;Gives it endpoint in C
;DE = size of data?
       push   de
;       in     a,(8Eh)       
;       add    a,a
;       ld     l,a
;       ld     h,0
;       ld     de,(MemPtr)
;       add    hl,de
       ld     hl,(MemPtr)                 ;**** NEW CODE FOR CALLBACK
       ld     de,offCallBackTable
       add    hl,de
       ld     a,(hl)
       inc    hl
       ld     h,(hl)
       ld     l,a
       or     h
       pop    de
       ret    z
       in     a,(8Eh)
       ld     c,a
       ASSERTC h,9Dh
       ASSERTC 3Fh,h
       jp     (hl)



LdHLFlags:
       ld     hl,(MemPtr)
       ld     de,offFlags
       add    hl,de
       ret
PumpOn:
       xor    a
       out    (5Bh),a
       LOG    PumpOn
       call   LdHLFlags
       set    flagPump,(hl)
       ret
PumpOff:
       LOG    PumpOff
       call   LdHLFlags
       res    flagPump,(hl)
       ld     a,1
       out    (5Bh),a
       ret
CheckPump:
       call   LdHLFlags
       bit    flagPump,(hl)
       ret
